﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CallCenter.Share.Dtos;
using FluentValidation;

namespace CallCenter.Application.Contracts.Validators
{
    public class TelToTelDtoValidator : AbstractValidator<TelToTelDto>
    {
        public TelToTelDtoValidator()
        {
            RuleFor(d => d.TelNo).NotEmpty();
        }
    }

    public class TelToOuterDtoValidator : AbstractValidator<TelToOuterDto>
    {
        public TelToOuterDtoValidator()
        {
            RuleFor(d => d.OuterNo).NotEmpty();
        }
    }

    public class VisitorToTelDtoValidator : AbstractValidator<VisitorToTelDto>
    {
        public VisitorToTelDtoValidator()
        {
            RuleFor(d => d.TelNo).NotEmpty();
        }
    }

    public class VisitorToOuterDtoValidator : AbstractValidator<VisitorToOuterDto>
    {
        public VisitorToOuterDtoValidator()
        {
            RuleFor(d => d.VisitorNo).NotEmpty();
            RuleFor(d => d.OuterNo).NotEmpty();
        }
    }

    public class OuterToOuterDtoValidator : AbstractValidator<OuterToOuterDto>
    {
        public OuterToOuterDtoValidator()
        {
            RuleFor(d => d.OuterNo).NotEmpty();
        }
    }

    public class OuterToTelDtoValidator : AbstractValidator<OuterToTelDto>
    {
        public OuterToTelDtoValidator()
        {
            RuleFor(d => d.TelNo).NotEmpty();
        }
    }
    
        
}
