﻿using CallCenter.Users;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CallCenter.Calls;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar
{
    public class CallRecordRepository: BaseRepository<CallRecord>, ICallRecordRepository, IScopeDependency
    {
        public CallRecordRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
        {
        }

        public async Task<CallRecord> GetCanDownVoice(CancellationToken cancellationToken)
        {
            var model = await Db.Queryable<CallRecord>().Where(x => !x.IsDown && x.Recording != "" && x.CreationTime < DateTime.Now.AddMinutes(1)).OrderBy(x => x.CreationTime).FirstAsync();
            return model;
        }
    }
}
