﻿using CallCenter.Calls;
using CallCenter.Share.Enums;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar
{
    public class CallRepository : BaseRepository<Call>, ICallRepository, IScopeDependency
    {
        public CallRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
        {
        }

        public async Task<IReadOnlyList<Call>> QueryPartAsync(DateTime datetime)
        {
            var a = await Db.Queryable<Call>()
                .Includes(d => d.CallDetails)
                //.Where(d => d.CallDetails.Any(x => x.EventName == "BYE") 
                .Where(d => !d.IsDeleted
                            && d.CallStatus == ECallStatus.Bye
                            && SqlFunc.Subqueryable<CallDetail>().Where(s => s.CallId == d.Id && s.EventName == "BYE" && s.CreationTime > datetime).Any())
                .OrderBy(d => d.CreationTime)
                .Take(10)
                .ToListAsync();

            return a;
        }
    }
}
