﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CallCenter.Ivrs;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar
{
    public class IvrRepository : BaseRepository<Ivr>, IIvrRepository, IScopeDependency
    {
        public IvrRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
        {
        }

        public async Task UpdateWithoutStrategiesAsync(Ivr ivr, CancellationToken cancellationToken = default)
        {
            await Db.Updateable(ivr).IgnoreColumns(d => d.IvrStrategies).ExecuteCommandAsync();
        }
    }
}
