﻿using CallCenter.Share.Dtos;
using CallCenter.Tels;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar;

public class TelGroupRepository : BaseRepository<TelGroup>, ITelGroupRepository, IScopeDependency
{
    public TelGroupRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
    {
    }

    public async Task UpdateNavTelsAsync(TelGroup group, CancellationToken cancellationToken = default)
    {
        await Db.UpdateNav(group)
            .Include(d => d.Tels, new UpdateNavOptions { ManyToManyIsUpdateA = true })
            .ExecuteCommandAsync();
    }

    public async Task AddNavTelsAsync(TelGroup group, CancellationToken cancellationToken = default)
    {
        await Db.InsertNav(group).Include(d => d.Tels).ExecuteCommandAsync();
    }
}