﻿using CallCenter.Tels;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar
{
    public class TelRepository : BaseRepository<Tel>, ITelRepository, IScopeDependency
    {
        public TelRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
        {
        }

        /// <summary>
        /// 分机是否正在休息
        /// </summary>
        /// <param name="telNo"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public Task<bool> IsRestingAsync(string telNo, CancellationToken cancellationToken)
        {
            return Db.Queryable<TelRest>().AnyAsync(d => d.TelNo == telNo && !d.EndTime.HasValue);
        }
    }
}
