﻿using CallCenter.Users;
using SqlSugar;
using XF.Domain.Dependency;

namespace CallCenter.Repository.SqlSugar;

public class WorkRepository : BaseRepository<Work>, IWorkRepository, IScopeDependency
{
    public WorkRepository(ISugarUnitOfWork<CallCenterDbContext> uow) : base(uow)
    {
    }

    public async Task<Work> GetCurrentWorkByUserAsync(string userId, CancellationToken cancellationToken = default)
        => await Db.Queryable<Work>().FirstAsync(d => d.UserId == userId && !d.EndTime.HasValue);

    public async Task<Work> GetCurrentWorkByTelAsync(string telNo, CancellationToken cancellationToken = default)
        => await Db.Queryable<Work>().FirstAsync(d => d.TelNo == telNo && !d.EndTime.HasValue);
}