﻿
using CallCenter.Share.Enums;
using XF.Utility.EnumExtensions;

namespace CallCenter.Share.Dtos
{
    public record CallDto
    {
        public string Id { get; set; }

        public DateTime CreationTime { get; set; }

        public ECallDirection CallDirection { get; set; }
        public string CallDirectionText => CallDirection.GetDescription();

        public ECallStatus CallStatus { get; set; }
        public string CallStatusText => CallStatus.GetDescription();

        public ECallType CallType { get; set; }
        public string CallTypeText => CallType.GetDescription();

        public string FromNo { get; set; }

        public string ToNo { get; set; }

        public EEndBy? EndBy { get; set; }
        public string EndByText => EndBy?.GetDescription() ?? string.Empty;

        public double? Duration { get; set; }

        public string UserName { get; set; }

        public ERingOffType? RingOffType { get; set; }
        public string RingOffTypeText => RingOffType?.GetDescription() ?? string.Empty;

        public EPhoneISP? PhoneIsp { get; set; }
        public string PhoneIspText => PhoneIsp?.GetDescription() ?? string.Empty;

        public string Attribution { get; set; }
    }
}
