﻿using CallCenter.Share.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenter.Share.Dtos
{
    public class OutCallDto
    {
        /// <summary>
        /// 通话记录ID
        /// </summary>
        public string CallId { get; set; }

        /// <summary>
        /// 信息类别
        /// </summary>
        public EInfoType InfoType { get; set; }

        /// <summary>
        /// 电话方向
        /// </summary>
        public ECallDirection Direction { get; set; }

        /// <summary>
        /// 主叫
        /// </summary>
        public string Cpn { get; set; }

        /// <summary>
        /// 被叫
        /// </summary>
        public string Cdpn { get; set; }

        /// <summary>
        /// 应答信息
        /// </summary>
        public string? Answered { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime BeginTime { get; set; }

        /// <summary>
        /// 接通时间
        /// </summary>
        public DateTime? OnTime { get; set; }

        /// <summary>
        /// 挂断时间
        /// </summary>
        public DateTime? ByeTime { get; set; }

        /// <summary>
        /// 通话时长
        /// </summary>
        public double? TalkTime { get; set; }

        /// <summary>
        /// 录音文件路径
        /// </summary>
        public string SoundFileName { get; set; }

        /// <summary>
        /// 评论结果
        /// </summary>
        public string EvaluateResult { get; set; }

        /// <summary>
        /// 挂机类型
        /// </summary>
        public EEndBy? EndBy { get; set; }

        /// <summary>
        /// 通话状态
        /// </summary>
        public EOnState OnState { get; set; }

        #region 2022年12月26日新增

        /// <summary>
        /// 进入IVR时间
        /// </summary>
        public DateTime? InIvrTime { get; set; }

        /// <summary>
        /// 离开IVR时间（进入队列时间）
        /// </summary>
        public DateTime? OutIvrTime { get; set; }
        
        /// <summary>
        /// 进入队列时间
        /// </summary>
        public DateTime? InGroupTime{ get; set; }

        /// <summary>
        /// 离开队列时间（振铃时间）
        /// </summary>
        public DateTime? OutGroupTime { get; set; }

        /// <summary>
        /// 进入坐席时间（振铃时间）
        /// </summary>
        public DateTime? InSeaTime { get; set; }

        /// <summary>
        /// 离开坐席时间（应答时间）
        /// </summary>
        public DateTime? ConnSeaTime { get; set; }

        #endregion

    }
}
