﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenter.Share.Dtos
{
    public record TelRestDto
    {
        /// <summary>
        /// 分机id
        /// </summary>
        public string TelId { get; set; }

        /// <summary>
        /// 分机号（冗余）
        /// </summary>
        public string TelNo { get; set; }

        /// <summary>
        /// 用户id
        /// </summary>
        public string UserId { get; set; }

        /// <summary>
        /// 用户名称（冗余）
        /// </summary>

        public string UserName { get; set; }

        /// <summary>
        /// 开始休息时间
        /// </summary>
        public DateTime StartTime { get; init; } = DateTime.Now;

        /// <summary>
        /// 结束休息时间
        /// </summary>
        public DateTime? EndTime { get; private set; }

        /// <summary>
        /// 休息时长（单位：秒）
        /// </summary>
        public double RestDuration { get; private set; }
    }
}
