﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CallCenter.Share.Requests;

namespace CallCenter.Calls
{
    public interface ICallDomainService
    {

        #region 来电
        /// <summary>
        /// 来电转分机
        /// </summary>
        /// <returns></returns>
        Task VisitorToTelAsync(VisitorIdToTelRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 来电转外线
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task VisitorToOuterAsync(VisitorToOuterRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 来电转IVR
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task VisitorToIvrAsync(VisitorToIvrRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 来电转分机组
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task VisitorToTelGroupAsync(VisitorToTelGroupRequest request, CancellationToken cancellationToken);


        #endregion

        #region 去电

        /// <summary>
        /// 分机呼外部电话
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task ExtToOuterAsync(ExtToOuterRequest request, CancellationToken cancellationToken);

        #endregion


        #region 强拆

        /// <summary>
        /// 强拆分机
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task ClearExtAsync(ClearExtRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 强拆来电
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task ClearVisitorAsync(ClearVisitorRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 强拆去电
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task ClearOuterAsync(ClearOuterRequest request, CancellationToken cancellationToken);

        #endregion

        #region 来电受理

        /// <summary>
        /// 来电受理
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task AcceptVisitorAsync(AcceptVisitorRequest request, CancellationToken cancellationToken);

        #endregion
    }
}
