﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Repository;

namespace CallCenter.Ivrs
{
    public interface IIvrCategoryRepository : IRepository<IvrCategory>
    {
        /// <summary>
        /// 查询所有分类（含IVR）
        /// </summary>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<IReadOnlyList<IvrCategory>> QueryCascadeAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// 查询某个分类（含IVR）
        /// </summary>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<IvrCategory> GetCascadeAsync(string id, CancellationToken cancellationToken = default);
    }
}
