﻿using CallCenter.Share.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenter.Realtimes
{
    public interface IRealtimeService
    {
        Task RingAsync(string userId, RingDto dto, CancellationToken cancellationToken);

        Task AnsweredAsync(string userId, AnseredDto dto, CancellationToken cancellationToken);

        Task ByeAsync(string userId, ByeDto dto, CancellationToken cancellationToken);
    }

    public record ByeDto
    {
        public string Id { get; set; }
    }


    public record RingDto
    {
        public string Id { get; set; }

        public string From { get; set; }

        public string To { get; set; }
        public ECallType CallType { get; set; }
        public string ConversationId { get; set; }
    }

    public record AnseredDto
    {
        public string Id { get; set; }

        public string From { get; set; }

        public string To { get; set; }

        public ECallType CallType { get; set; }

        public string ConversationId { get; set; }
    }
}
